# css-modules-flow-types-loader [![Build Status](https://travis-ci.org/skovhus/css-modules-flow-types.svg?branch=master)](https://travis-ci.org/skovhus/css-modules-flow-types) [![npm version](https://badge.fury.io/js/css-modules-flow-types-loader.svg)](http://badge.fury.io/js/css-modules-flow-types-loader)

Webpack loader for creating [Flow](https://flow.org/) type definitions based on [CSS Modules](https://github.com/css-modules/css-modules) files.

This gives you:
- auto-completing for css files in most editors
- flow type safety showing usage of non existing classes


## Example

Given the following css file using CSS Modules:
```css
@value primary: red;

.myClass {
  color: primary;
}
```

`css-modules-flow-types` creates the following .flow file next to it:

```javascript
// @flow
/* This file is automatically generated by css-modules-flow-types */
declare module.exports: {|
  +'myClass': string;
  +'primary': string;
|};
```


## Usage

The `css-modules-flow-types-loader` need to be added right after after `style-loader`:

```sh
$ npm install --dev css-modules-flow-types-loader
$ yarn install -D css-modules-flow-types-loader
```

```javascript
{
  test: /\.css$/,  // or the file format you are using for your CSS Modules
  use: [
    'style-loader',
    'css-modules-flow-types-loader',
    // Other loaders like css-loader after this:
    {
      ...
    }
  ]
}
```


## Inspiration
- https://github.com/Quramy/typed-css-modules
- https://github.com/Jimdo/typings-for-css-modules-loader


## License
This software is released under the MIT License.
